Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 1014)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 1015)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! ------------------
-!
+! accelerator versions (*_acc) added
 !
 ! Former revisions:
@@ -88,5 +88,6 @@
 
     PRIVATE
-    PUBLIC   advec_s_ws, advec_u_ws, advec_v_ws, advec_w_ws, &
+    PUBLIC   advec_s_ws, advec_s_ws_acc, advec_u_ws, advec_u_ws_acc, &
+             advec_v_ws, advec_v_ws_acc, advec_w_ws, advec_w_ws_acc, &
              ws_init, ws_statistics
 
@@ -109,4 +110,8 @@
     END INTERFACE advec_u_ws
 
+    INTERFACE advec_u_ws_acc
+       MODULE PROCEDURE advec_u_ws_acc
+    END INTERFACE advec_u_ws_acc
+
     INTERFACE advec_v_ws
        MODULE PROCEDURE advec_v_ws
@@ -114,8 +119,16 @@
     END INTERFACE advec_v_ws
 
+    INTERFACE advec_v_ws_acc
+       MODULE PROCEDURE advec_v_ws_acc
+    END INTERFACE advec_v_ws_acc
+
     INTERFACE advec_w_ws
        MODULE PROCEDURE advec_w_ws
        MODULE PROCEDURE advec_w_ws_ij
     END INTERFACE advec_w_ws
+
+    INTERFACE advec_w_ws_acc
+       MODULE PROCEDURE advec_w_ws_acc
+    END INTERFACE advec_w_ws_acc
 
  CONTAINS
@@ -2335,4 +2348,286 @@
 
 !------------------------------------------------------------------------------!
+! Scalar advection - Call for all grid points - accelerator version
+!------------------------------------------------------------------------------!
+    SUBROUTINE advec_s_ws_acc ( sk, sk_char )
+
+       USE arrays_3d
+       USE constants
+       USE control_parameters
+       USE grid_variables
+       USE indices
+       USE statistics
+
+       IMPLICIT NONE
+
+       CHARACTER (LEN = *), INTENT(IN)    :: sk_char
+
+       INTEGER ::  i, ibit0, ibit1, ibit2, ibit3, ibit4, ibit5, ibit6,        &
+                   ibit7, ibit8, j, k, k_mm, k_mmm, k_pp, k_ppp, tn = 0
+
+       REAL    :: diss_d, diss_l, diss_n, diss_r, diss_s, diss_t, div, flux_d, &
+                  flux_l, flux_n, flux_r, flux_s, flux_t, u_comp, v_comp
+
+       REAL, INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  ::  sk
+
+!
+!--    Computation of fluxes and tendency terms
+       !$acc kernels present( ddzw, sk, tend, u, v, w, wall_flags_0 )
+       !$acc loop
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             !$acc loop vector( 32 )
+             DO  k = nzb+1, nzt
+
+                ibit2 = IBITS(wall_flags_0(k,j,i),2,1)
+                ibit1 = IBITS(wall_flags_0(k,j,i),1,1)
+                ibit0 = IBITS(wall_flags_0(k,j,i),0,1)
+
+                u_comp              = u(k,j,i) - u_gtrans
+                flux_l              = u_comp * (                           &
+                                               ( 37.0 * ibit2 * adv_sca_5  &
+                                            +     7.0 * ibit1 * adv_sca_3  &
+                                            +           ibit0 * adv_sca_1  &
+                                               ) *                         &
+                                         ( sk(k,j,i)   + sk(k,j,i-1)    )  &
+                                        -      (  8.0 * ibit2 * adv_sca_5  &
+                                            +           ibit1 * adv_sca_3  &
+                                               ) *                         &
+                                         ( sk(k,j,i+1) + sk(k,j,i-2)    )  &
+                                        +      (        ibit2 * adv_sca_5  &
+                                               ) *                         &
+                                         ( sk(k,j,i+2) + sk(k,j,i-3)    )  &
+                                            )
+
+                diss_l              = -ABS( u_comp ) * (                   &
+                                               ( 10.0 * ibit2 * adv_sca_5  &
+                                            +     3.0 * ibit1 * adv_sca_3  &
+                                            +           ibit0 * adv_sca_1  &
+                                               ) *                         &
+                                         ( sk(k,j,i)   - sk(k,j,i-1)    )  &
+                                        -      (  5.0 * ibit2 * adv_sca_5  &
+                                            +           ibit1 * adv_sca_3  &
+                                               ) *                         &
+                                         ( sk(k,j,i+1) - sk(k,j,i-2)  )    &
+                                        +      (        ibit2 * adv_sca_5  &
+                                               ) *                         &
+                                         ( sk(k,j,i+2) - sk(k,j,i-3) )     &
+                                                    )
+
+                u_comp    = u(k,j,i+1) - u_gtrans
+                flux_r    = u_comp * (                                      &
+                          ( 37.0 * ibit2 * adv_sca_5                        &
+                      +      7.0 * ibit1 * adv_sca_3                        &
+                      +            ibit0 * adv_sca_1                        &
+                          ) *                                               &
+                             ( sk(k,j,i+1) + sk(k,j,i)   )                  &
+                   -      (  8.0 * ibit2 * adv_sca_5                        &
+                       +           ibit1 * adv_sca_3                        &
+                          ) *                                               &
+                             ( sk(k,j,i+2) + sk(k,j,i-1) )                  &
+                   +      (        ibit2 * adv_sca_5                        &
+                          ) *                                               &
+                             ( sk(k,j,i+3) + sk(k,j,i-2) )                  &
+                                     )
+
+                diss_r    = -ABS( u_comp ) * (                              &
+                          ( 10.0 * ibit2 * adv_sca_5                        &
+                       +     3.0 * ibit1 * adv_sca_3                        &
+                       +           ibit0 * adv_sca_1                        &
+                          ) *                                               &
+                             ( sk(k,j,i+1) - sk(k,j,i)  )                   &
+                   -      (  5.0 * ibit2 * adv_sca_5                        &
+                       +           ibit1 * adv_sca_3                        &
+                          ) *                                               &
+                             ( sk(k,j,i+2) - sk(k,j,i-1) )                  &
+                   +      (        ibit2 * adv_sca_5                        &
+                          ) *                                               &
+                             ( sk(k,j,i+3) - sk(k,j,i-2) )                  &
+                                             )
+
+                ibit5 = IBITS(wall_flags_0(k,j,i),5,1)
+                ibit4 = IBITS(wall_flags_0(k,j,i),4,1)
+                ibit3 = IBITS(wall_flags_0(k,j,i),3,1)
+
+                v_comp               = v(k,j,i) - v_gtrans
+                flux_s               = v_comp * (                             &
+                                                  ( 37.0 * ibit5 * adv_sca_5  &
+                                               +     7.0 * ibit4 * adv_sca_3  &
+                                               +           ibit3 * adv_sca_1  &
+                                                  ) *                         &
+                                           ( sk(k,j,i)  + sk(k,j-1,i)     )   &
+                                            -     (  8.0 * ibit5 * adv_sca_5  &
+                                               +           ibit4 * adv_sca_3  &
+                                                   ) *                        &
+                                           ( sk(k,j+1,i) + sk(k,j-2,i)    )   &
+                                           +      (        ibit5 * adv_sca_5  &
+                                                  ) *                         &
+                                           ( sk(k,j+2,i) + sk(k,j-3,i)    )   &
+                                             )
+
+                diss_s               = -ABS( v_comp ) * (                     &
+                                                  ( 10.0 * ibit5 * adv_sca_5  &
+                                               +     3.0 * ibit4 * adv_sca_3  &
+                                               +           ibit3 * adv_sca_1  &
+                                                  ) *                         &
+                                            ( sk(k,j,i)   - sk(k,j-1,i)    )  &
+                                           -      (  5.0 * ibit5 * adv_sca_5  &
+                                               +           ibit4 * adv_sca_3  &
+                                            ) *                               &
+                                            ( sk(k,j+1,i) - sk(k,j-2,i)  )    &
+                                           +      (        ibit5 * adv_sca_5  &
+                                                  ) *                         &
+                                            ( sk(k,j+2,i) - sk(k,j-3,i) )     &
+                                                     )
+
+
+                v_comp    = v(k,j+1,i) - v_gtrans
+                flux_n    = v_comp * (                                      &
+                          ( 37.0 * ibit5 * adv_sca_5                        &
+                       +     7.0 * ibit4 * adv_sca_3                        &
+                       +           ibit3 * adv_sca_1                        &
+                          ) *                                               &
+                             ( sk(k,j+1,i) + sk(k,j,i)   )                  &
+                   -      (  8.0 * ibit5 * adv_sca_5                        &
+                       +           ibit4 * adv_sca_3                        &
+                          ) *                                               &
+                             ( sk(k,j+2,i) + sk(k,j-1,i) )                  &
+                   +      (        ibit5 * adv_sca_5                        &
+                          ) *                                               &
+                             ( sk(k,j+3,i) + sk(k,j-2,i) )                  &
+                                     )
+
+                diss_n    = -ABS( v_comp ) * (                              &
+                          ( 10.0 * ibit5 * adv_sca_5                        &
+                       +     3.0 * ibit4 * adv_sca_3                        &
+                       +           ibit3 * adv_sca_1                        &
+                          ) *                                               &
+                             ( sk(k,j+1,i) - sk(k,j,i)    )                 &
+                   -      (  5.0 * ibit5 * adv_sca_5                        &
+                       +           ibit4 * adv_sca_3                        &
+                          ) *                                               &
+                             ( sk(k,j+2,i) - sk(k,j-1,i)  )                 &
+                   +      (        ibit5 * adv_sca_5                        &
+                          ) *                                               &
+                             ( sk(k,j+3,i) - sk(k,j-2,i) )                  &
+                                             )
+
+!
+!--             indizes k_m, k_mm, ... should be known at these point
+                ibit8 = IBITS(wall_flags_0(k-1,j,i),8,1)
+                ibit7 = IBITS(wall_flags_0(k-1,j,i),7,1)
+                ibit6 = IBITS(wall_flags_0(k-1,j,i),6,1)
+
+                k_pp  = k + 2 * ( 1 - ibit6 )
+                k_mm  = k - 2 * ( 1 - ibit6 )
+                k_mmm = k - 3 * ibit8
+
+                flux_d    = w(k-1,j,i) * (                                    &
+                           ( 37.0 * ibit8 * adv_sca_5                         &
+                        +     7.0 * ibit7 * adv_sca_3                         &
+                        +           ibit6 * adv_sca_1                         &
+                           ) *                                                &
+                                   ( sk(k,j,i)    + sk(k-1,j,i) )             &
+                          -      (  8.0 * ibit8 * adv_sca_5                   &
+                          +               ibit7 * adv_sca_3                   &
+                           ) *                                                &
+                                   ( sk(k+1,j,i) + sk(k_mm,j,i) )             &
+                    +      (        ibit8 * adv_sca_5                         &
+                           ) *     ( sk(k_pp,j,i)+ sk(k_mmm,j,i) )            &
+                                       )
+
+                diss_d    = -ABS( w(k-1,j,i) ) * (                            &
+                           ( 10.0 * ibit8 * adv_sca_5                         &
+                        +     3.0 * ibit7 * adv_sca_3                         &
+                        +           ibit6 * adv_sca_1                         &
+                           ) *                                                &
+                                   ( sk(k,j,i)    - sk(k-1,j,i)   )           &
+                    -      (  5.0 * ibit8 * adv_sca_5                         &
+                        +           ibit7 * adv_sca_3                         &
+                           ) *                                                &
+                                   ( sk(k+1,j,i)  - sk(k_mm,j,i)  )           &
+                    +      (        ibit8 * adv_sca_5                         &
+                           ) *                                                &
+                                   ( sk(k_pp,j,i) - sk(k_mmm,j,i) )           &
+                                         )
+
+                ibit8 = IBITS(wall_flags_0(k,j,i),8,1)
+                ibit7 = IBITS(wall_flags_0(k,j,i),7,1)
+                ibit6 = IBITS(wall_flags_0(k,j,i),6,1)
+
+                k_ppp = k + 3 * ibit8
+                k_pp  = k + 2 * ( 1 - ibit6  )
+                k_mm  = k - 2 * ibit8
+
+                flux_t    = w(k,j,i) * (                                      &
+                           ( 37.0 * ibit8 * adv_sca_5                         &
+                        +     7.0 * ibit7 * adv_sca_3                         &
+                        +           ibit6 * adv_sca_1                         &
+                           ) *                                                &
+                                   ( sk(k+1,j,i)  + sk(k,j,i)   )             &
+                          -      (  8.0 * ibit8 * adv_sca_5                   &
+                        +                 ibit7 * adv_sca_3                   &
+                           ) *                                                &
+                                   ( sk(k_pp,j,i) + sk(k-1,j,i) )             &
+                    +      (        ibit8 * adv_sca_5                         &
+                           ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )            &
+                                       )
+
+                diss_t    = -ABS( w(k,j,i) ) * (                              &
+                           ( 10.0 * ibit8 * adv_sca_5                         &
+                        +     3.0 * ibit7 * adv_sca_3                         &
+                        +           ibit6 * adv_sca_1                         &
+                           ) *                                                &
+                                   ( sk(k+1,j,i)   - sk(k,j,i)    )           &
+                    -      (  5.0 * ibit8 * adv_sca_5                         &
+                        +           ibit7 * adv_sca_3                         &
+                           ) *                                                &
+                                   ( sk(k_pp,j,i)  - sk(k-1,j,i)  )           &
+                    +      (        ibit8 * adv_sca_5                         &
+                           ) *                                                &
+                                   ( sk(k_ppp,j,i) - sk(k_mm,j,i) )           &
+                                         )
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities caused
+!--             by a not sufficient reduction of divergences near topography.
+                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx             &
+                              + ( v(k,j+1,i) - v(k,j,i)   ) * ddy             &
+                              + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+
+                tend(k,j,i) = - (                                             &
+                               ( flux_r + diss_r - flux_l - diss_l ) * ddx    &
+                             + ( flux_n + diss_n - flux_s - diss_s ) * ddy    &
+                             + ( flux_t + diss_t - flux_d - diss_d ) * ddzw(k)&
+                                ) + div * sk(k,j,i)
+
+!++
+!--             Evaluation of statistics
+!                SELECT CASE ( sk_char )
+!
+!                   CASE ( 'pt' )
+!                      sums_wspts_ws_l(k,tn) = sums_wspts_ws_l(k,tn)         &
+!                       + ( flux_t + diss_t )                                &
+!                       *   weight_substep(intermediate_timestep_count)
+!                   CASE ( 'sa' )
+!                      sums_wssas_ws_l(k,tn) = sums_wssas_ws_l(k,tn)         &
+!                       + ( flux_t + diss_t )                                &
+!                       *   weight_substep(intermediate_timestep_count)
+!                   CASE ( 'q' )
+!                      sums_wsqs_ws_l(k,tn) = sums_wsqs_ws_l(k,tn)           &
+!                      + ( flux_t + diss_t )                                &
+!                      *   weight_substep(intermediate_timestep_count)
+!
+!                END SELECT
+
+             ENDDO
+         ENDDO
+      ENDDO
+      !$acc end kernels
+
+    END SUBROUTINE advec_s_ws_acc
+
+
+!------------------------------------------------------------------------------!
 ! Advection of u - Call for all grid points
 !------------------------------------------------------------------------------!
